/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.thin.sample.service.blogic;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Map;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.upload.FormFile;
import jp.terasoluna.fw.batch.commonj.init.JobStarter;

import jp.terasoluna.fw.service.thin.BLogic;
import jp.terasoluna.fw.service.thin.BLogicMessage;
import jp.terasoluna.fw.service.thin.BLogicMessages;
import jp.terasoluna.fw.service.thin.BLogicResult;

/**
 * 
 * ファイルをアップロードし、batchを起動するビジネスロジッククラス。
 *
 */
public class StartBatchBLogicImpl implements BLogic<Map<String, Object>> {
    
    /**
     * ファイルアップロード先のディレクトリ名
     */
    private static String FILEUP_DIR = "tmp/";
    
    /**
     * 正常時終了コード
     */
    private static int NORMAL_END_CODE = 0;
    
    
    /**
     * 異常時終了コード
     */
    private static int ERROR_END_CODE = 400;


    /**
     * ログクラス。
     */
    private static final Log log = LogFactory.getLog(StartBatchBLogicImpl.class);
    
    
    /**
     * ジョブスタータ
     * Springによりインスタンス生成され設定される。
     */
    private JobStarter jobStarter = null;
    
    
    /**
     * ビジネスロジックの実行としてファイルアップロードとバッチの起動を行う
     * @param map プロパティ
     * @return ビジネスロジック結果オブジェクト
     */
    public BLogicResult execute(Map<String, Object> map) {
        
        //入金データファイルフォームファイルを取得
        FormFile fileUp = (FormFile) map.get("fileUp");
        
        //ファイル名
        String fileName = fileUp.getFileName();
        
        //入金データファイル配置処理
        int fileUPEndCode = fileUpLoad(fileUp);
        
        //ファイルアップロードがされなかった際の異常終了処理
        if (fileUPEndCode == ERROR_END_CODE) {
            //結果返却処理
            
            //ビジネスロジックの結果オブジェクト生成
            BLogicResult result = new BLogicResult();
            
            //ビジネスロジックの結果文字列に"failure"を設定し、返却する。
            result.setResultString("failure");
            
            //表示するメッセージの生成、設定
            BLogicMessages messages = new BLogicMessages();
            
            //メッセージに表示するファイル名の設定
            String[] mesargs = {fileName};
            
            //終了コードが0でない場合：異常メッセージを設定
             messages.add("fileUp.error",
                        new BLogicMessage("fileUp.error", mesargs));
            
            //エラーメッセージの設定をする
            result.setErrors(messages);
            
            return result;
        }
            
        //入金データ取込ジョブ起動処理
        //入金データファイルのパスを第３引数とし、入金データ取込残高計算ジョブ(JOB01)を起動する。
        String path = FILEUP_DIR + fileUp.getFileName();
        String[] args = {path};
        
        //ジョブの起動
        int jobEndCode = jobStarter.execute("Job01", "sample/JOB01.xml", args);
        
        //ビジネスロジックの結果オブジェクト生成
        BLogicResult result = new BLogicResult();
        
        //表示するメッセージの生成、設定
        BLogicMessages messages = new BLogicMessages();
        
        //メッセージに表示するファイル名の設定
        String[] mesargs = {fileName};
        
        //ジョブの終了コードを受け取り、正常／異常メッセージを表示する。
        //終了コードが0の場合：正常メッセージを設定する
        if (jobEndCode == NORMAL_END_CODE) {
            
            //ビジネスロジックの結果文字列に"success"を設定し、返却する。	
            result.setResultString("success");
            
            //メッセージの設定をする
            messages.add("batch.success",
                    new BLogicMessage("batch.success", mesargs));
            result.setMessages(messages);
        }
        //終了コードが0でない場合：異常メッセージを設定
        else {

            //ビジネスロジックの結果文字列に"failure"を設定し、返却する。	
            result.setResultString("failure");
            
            //エラーメッセージの設定をする
            messages.add("batch.error",
                    new BLogicMessage("batch.error", mesargs));
            result.setErrors(messages);
        }
        
        return result;
    }
    
    /**
     * 入金データファイルをファイルアップロードを行う
     * @param fileUp アップロードファイルのフォームファイル
     */
    private int fileUpLoad(FormFile fileUp) {
        
        //入力ストリームバッファ
        BufferedInputStream inBuffer = null;
        
        //出力ストリームバッファ
        BufferedOutputStream outBuffer = null;
        
        
        //ファイル名
        String fileName = fileUp.getFileName();
        
        //末尾が.csvでない。あるいはファイルサイズが0である場合には異常終了コードを返す
        if (! (fileName.endsWith(".csv") || fileName.endsWith(".CSV"))
                || fileUp.getFileSize() == 0) {
            return ERROR_END_CODE;
        }
        
        //入力値の入金データファイルを『tmp』フォルダに配置する。				
        try {	
            //getInputStreamメソッドを使用し、入力ストリームを取得
            InputStream is = fileUp.getInputStream();
            
            //入力ストリームをバッファリング
            inBuffer = new BufferedInputStream(is);
            

            //ファイルアップロード先のパス設定
            String path = FILEUP_DIR + fileUp.getFileName();
            
            //ファイルのアップロード先を指定して、出力ストリームを生成
            FileOutputStream fos = new FileOutputStream(path);
        
            
            //出力ストリームをバッファリング
            outBuffer = new BufferedOutputStream(fos);
            
            
            //入力データがなくなるまで入出力処理を実行
            int data = 0;
            while ((data = inBuffer.read()) != -1) {
                outBuffer.write(data);
            }
            
        } catch (FileNotFoundException e) {
            //表示するメッセージの生成、設定
            BLogicMessages messages = new BLogicMessages();
            messages.add("fileUp.uploadingError",
                    new BLogicMessage("fileUp.uploadingError"));
            log.error(messages);
            return ERROR_END_CODE;
        } catch (IOException e) {
            //表示するメッセージの生成、設定
            BLogicMessages messages = new BLogicMessages();
            messages.add("fileUp.uploadingError",
                    new BLogicMessage("fileUp.uploadingError"));
            log.error(messages);
            return ERROR_END_CODE;
        } finally {
            
            try {
                //解放
                if (outBuffer != null) {
                    outBuffer.flush();
                    outBuffer.close();
                }
                if (inBuffer != null) {
                    inBuffer.close();
                }
            } catch (IOException e) {
                //表示するメッセージの生成、設定
                BLogicMessages messages = new BLogicMessages();
                messages.add("fileUp.uploadingError",
                        new BLogicMessage("fileUp.uploadingError"));
                log.error(messages);
                return ERROR_END_CODE;
            }
            
            //一時領域のアップロードデータを削除
            fileUp.destroy();
        }
        
        return NORMAL_END_CODE;
    }

    
    /**
     * ジョブスタータを設定する
     * @param jobStarter
     */
    public void setJobStarter(JobStarter jobStarter) {
        this.jobStarter = jobStarter;
    }

}
